#include <iostream>
using namespace std;

class Point2D {

public:
	explicit Point2D(double x = 0, double y = 0) : x{x}, y{y} {}

//private:
protected:
	double x, y;
};

class Point3D : public Point2D {

public:
	Point3D(double x, double y, double z) : Point2D{x, y}, z{z} {}
	explicit Point3D(double z = 0) : z{z} {}
	void print() {
		cout << "(" << x << ", " << y << ", " << z << ")" << endl;
	}

private:
	double z;
};

int main () {

	Point3D(1, 2, 3).print();
	Point3D(5).print();
	Point3D().print();
	return 0;
}

